#!/usr/bin/ruby -Ku
# $Id: setup_ubuntu_linux.rb,v 1.8 2009/08/31 12:31:19 nishimoto Exp $
# for ubuntu 9.04 ja remix

UT_BASE = "http://hil.t.u-tokyo.ac.jp/~nishi/galatea/work"
UT_ID = 'galatea'
UT_PW = ARGV[0]
unless UT_PW
  puts "setup.rb galatea-server-pw"
  exit 
end
SFJP_BASE = 'http://sourceforge.jp/cvs/view/galatea/galatea-dialog-studio/files/'

# euc-jp locale
if File.exist?("/var/lib/locales/supported.d/local")
  if `grep EUC-JP /var/lib/locales/supported.d/local` == ''
    system 'sudo chmod 666 /var/lib/locales/supported.d/local'
    system 'sudo echo "ja_JP.EUC-JP EUC-JP" >> /var/lib/locales/supported.d/ja'
    system 'sudo echo "ja_JP.EUC-JP EUC-JP" >> /var/lib/locales/supported.d/local'
    system 'sudo locale-gen'
    # system 'sudo update-locale LANG=ja_JP.EUC-JP'
    puts 'EUC-JP locale generated'
  else
    puts 'EUC-JP already supported'
  end
else
  system 'sudo echo "ja_JP.EUC-JP EUC-JP" >> /var/lib/locales/supported.d/ja'
  system 'sudo echo "ja_JP.EUC-JP EUC-JP" >> /var/lib/locales/supported.d/local'
  system 'sudo locale-gen'
  # system 'sudo update-locale LANG=ja_JP.EUC-JP'
  puts 'EUC-JP locale generated'
end

# galatea
%w[ libstdc++5 freeglut3 openjdk-6-jre wavesurfer kterm sox irb lv ].each do |f|
  system "sudo apt-get install -y #{f}"
end
system 'sudo apt-get install wget'
%w[ galatea-dialog_20090831-2_i386.deb
    galatea-engine_20090604-1_i386.deb
    galatea-ja-chaone_1.3.2-1_i386.deb
    galatea-ja-chasen_20090603-1_i386.deb
    galatea-ja-unidic_20090604-1_i386.deb ].each do |f|
  system "wget --http-user=#{UT_ID} --http-password=#{UT_PW} #{UT_BASE}/#{f}"
  system "sudo dpkg -i #{f}"
end

# additional files

# %w[ misc/galatea-killall?revision=1.1 ].each do |f|
#   wf = File.basename(f.split(/\?/)[0])
#   dir = "/usr/local/bin"
#   system "wget -O #{wf} #{SFJP_BASE}/#{f}"
#   system "sudo cp #{wf} #{dir}/#{wf}"
#   system "sudo chmod 755 #{dir}/#{wf}"
# end

system "sudo mkdir /usr/local/galatea-demo"
%w[ tests/vxml/ticket.vxml?revision=HEAD
    tests/vxml/form.vxml?revision=HEAD ].each do |f|
  wf = File.basename(f.split(/\?/)[0])
  dir = "/usr/local/galatea-demo"
  system "wget -O #{wf} #{SFJP_BASE}/#{f}"
  system "sudo cp #{wf} #{dir}/#{wf}"
  system "sudo chmod 755 #{dir}/#{wf}"
end

# replace rubygems
system 'sudo apt-get install -y rubygems1.8'
system 'wget http://rubyforge.org/frs/download.php/60717/rubygems-update-1.3.5.gem'
system 'sudo gem install rubygems-update-1.3.5.gem'
system 'sudo /var/lib/gems/1.8/bin/update_rubygems'
system 'pushd /usr/bin ; sudo mv gem gem.debian ; sudo ln -s gem1.8 gem; popd'

# ruby on rails
system 'sudo apt-get install -y ruby1.8-dev swig libsqlite3-dev libopenssl-ruby'
system 'sudo gem1.8 install --no-rdoc --no-ri sqlite3-ruby'
system 'sudo gem1.8 install --no-rdoc --no-ri rails -v 2.0.2'

# end
